<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { fly } from "svelte/transition";
  const dispatch = createEventDispatcher();
  function performAction(action: Action) {
    dispatch("action", action);
  }

  import MissionCardBack from "./MissionCardBack.svelte";
  import MissionCardFront from "./MissionCardFront.svelte";
  import { getAffiliation, isPlayerActive } from "./theResistance";

  export let state: GameState;
  export let phase: MissionInProgress;

  export let player: PlayerState;
  export let user: PlayerState | undefined;

  $: teamMembers = Object.keys(phase.MissionInProgress.cards).map((str) =>
    parseInt(str)
  );
  $: isInMission = teamMembers.includes(player.id);
  $: isActive = isPlayerActive(state, player.id);
</script>

{#if isInMission && isActive}
  <ul class="cards">
    {#if user?.id === player.id}
      <li class="user-card">
        <button
          disabled={getAffiliation(player.hand) !== "Spies"}
          on:click={() => {
            performAction({ PlayMissionCard: { card: "Fail" } });
          }}
        >
          <MissionCardFront card="Fail" />
        </button>
      </li>
      <li class="user-card">
        <button
          on:click={() => {
            performAction({ PlayMissionCard: { card: "Success" } });
          }}
        >
          <MissionCardFront card="Success" />
        </button>
      </li>
    {:else}
      <li>
        <MissionCardBack />
      </li>
      <li>
        <MissionCardBack />
      </li>
    {/if}
  </ul>
{/if}

<style>
  .cards {
    position: relative;
  }
  .cards > li {
    position: absolute;
    top: 0%;
    left: 50%;
    transform-origin: center 50em;
  }
  .cards > li:first-child {
    transform: translate(-50%, -80%) rotate(-3deg);
  }
  .cards > li:last-child {
    transform: translate(-50%, -80%) rotate(3deg);
  }

  .cards > li.user-card:first-child {
    transform: translate(-50%, -110%) rotate(-6deg);
  }
  .cards > li.user-card:last-child {
    transform: translate(-50%, -110%) rotate(6deg);
  }

  button {
    transition: transform 0.25s;
    cursor: pointer;
    padding: none;
    border: none;
    background: none;

    font-size: inherit;
  }
  button:disabled {
    cursor: not-allowed;
    filter: grayscale(0.9) opacity(0.9);
  }
  button:not(:disabled):hover,
  button:not(:disabled):focus {
    transform: translateY(-1.5em);
  }
</style>
